unit Cadfrm;
{ You can use that form in your project only with the license that came with
  CADSys. }

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, CAD2DCmp,
  ObjList, Obj2D, Prim2D, Block2D, GrLib2D, Spline2D, { This unit must be included. }
  Menus, ExtCtrls, StdCtrls, Buttons, Spin, Printers;

type
  TAction = (caNone, caMakingPoly, caSelectArea, caMove, caSelectBaseBlock,
             caPanningP1, caPanningP2);

  TCADForm = class(TForm)
    ViewportPnl: TPanel;
    InfoPnl: TPanel;
    CADMenu: TMainMenu;
    Objects1: TMenuItem;
    Line1: TMenuItem;
    Rectangle1: TMenuItem;
    Ellipse1: TMenuItem;
    Arc1: TMenuItem;
    Polyline1: TMenuItem;
    Polygon1: TMenuItem;
    Text1: TMenuItem;
    Blocks1: TMenuItem;
    Copyblock1: TMenuItem;
    Moveobjectstoblock1: TMenuItem;
    Edit1: TMenuItem;
    Delete1: TMenuItem;
    View1: TMenuItem;
    ZoomIn1: TMenuItem;
    ZoomOut1: TMenuItem;
    ZoomAll1: TMenuItem;
    ZoomArea1: TMenuItem;
    Panning1: TMenuItem;
    ViewPort1: TViewPort;
    CADCmp1: TCADCmp;
    Aspectratio1: TMenuItem;
    Layers1: TMenuItem;
    VisAreaLbl: TLabel;
    PosLbl: TLabel;
    N1: TMenuItem;
    ChangeControlPoints: TMenuItem;
    N2: TMenuItem;
    Showgrid1: TMenuItem;
    InfoLbl: TLabel;
    File1: TMenuItem;
    Open1: TMenuItem;
    Save1: TMenuItem;
    N3: TMenuItem;
    Quit1: TMenuItem;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    PopupMenu1: TPopupMenu;
    Zoomin2: TMenuItem;
    Zoomout2: TMenuItem;
    Zoomall2: TMenuItem;
    Panning2: TMenuItem;
    Zoomarea2: TMenuItem;
    SpinLayer: TSpinEdit;
    Bevel1: TBevel;
    Bevel2: TBevel;
    Bevel3: TBevel;
    Rotate1: TMenuItem;
    BSpline1: TMenuItem;
    Test1: TMenuItem;
    Setgridstep1: TMenuItem;
    Doubleextension1: TMenuItem;
    Divideextension1: TMenuItem;
    Print1: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure ViewPort1MouseMove2D(Sender: TObject; Shift: TShiftState; WX,
      WY: Single);
    procedure ViewPort1MouseDown2D(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; WX, WY: Single);
    procedure ViewPort1MouseUp2D(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; WX, WY: Single);
    procedure Line1Click(Sender: TObject);
    procedure ChangeControlPointsClick(Sender: TObject);
    procedure Polyline1Click(Sender: TObject);
    procedure Polygon1Click(Sender: TObject);
    procedure Rectangle1Click(Sender: TObject);
    procedure Ellipse1Click(Sender: TObject);
    procedure Text1Click(Sender: TObject);
    procedure Arc1Click(Sender: TObject);
    procedure ViewPort1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ViewPort1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure ZoomArea1Click(Sender: TObject);
    procedure Moveobjectstoblock1Click(Sender: TObject);
    procedure Copyblock1Click(Sender: TObject);
    procedure Delete1Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Showgrid1Click(Sender: TObject);
    procedure ZoomAll1Click(Sender: TObject);
    procedure ZoomIn1Click(Sender: TObject);
    procedure ZoomOut1Click(Sender: TObject);
    procedure Aspectratio1Click(Sender: TObject);
    procedure Open1Click(Sender: TObject);
    procedure Save1Click(Sender: TObject);
    procedure Panning1Click(Sender: TObject);
    procedure Layers1Click(Sender: TObject);
    procedure SpinLayerChange(Sender: TObject);
    procedure Quit1Click(Sender: TObject);
    procedure Rotate1Click(Sender: TObject);
    procedure BSpline1Click(Sender: TObject);
    procedure Test1Click(Sender: TObject);
    procedure CADCmp1ListChange(Sender: TObject; NewObj: TObject2D);
    procedure Setgridstep1Click(Sender: TObject);
    procedure Doubleextension1Click(Sender: TObject);
    procedure Divideextension1Click(Sender: TObject);
    procedure Print1Click(Sender: TObject);
  private
    { Private declarations }
    VisibleObjects: TObj2DList; { Will contain the visible objects for fast redraw. }
    CurrAction: TAction;
    BeginArea: TPoint2D;
    Moved: Boolean;
    MyNextID: LongInt;
    SavedTransf: TTransf2D;
    PickedObjects: TObj2DList; { Contain the objects currently selected. }
    PickedPoint: Integer; { Contain the point selected on the PickedObject. }
    PickedPointOrigin: TPoint2D; { Contain the base point for moving object. }
    procedure UpdateAreaString;
    procedure AddAnObject(Obj: TObject2D);
    procedure ShowPickedObjects(Where: TWhereToDraw);
    procedure UnShowPickedObjects(Where: TWhereToDraw);
  public
    { Public declarations }
  end;

var
  CADForm: TCADForm;

implementation

uses LayerDlg, ZoomFrm;

{$R *.DFM}

var
  Ora: TDateTime;
  PMem, EMem: LongInt;

procedure SetTime;
begin
  Screen.Cursor := crHourGlass;
  PMem := MemAvail;
  Ora := Now;
end;

procedure ShowTime;
var
  H, M, S, MS: Word;
begin
  DecodeTime(Now - Ora, H, M, S, MS);
  Screen.Cursor := crDefault;
  EMem := MemAvail;
  ShowMessage('Tempo utilizzato: ' + IntToStr(S) + 's e ' + IntToStr(MS) + 'ms' + #13
              + 'Memoria utilizzata: ' + IntToStr(PMem - EMem));
end;

procedure TCADForm.ShowPickedObjects(Where: TWhereToDraw);
begin
  if PickedObjects.First = nil then Exit;
  { Show the objects. }
  Viewport1.WhereToDraw := Where;
  repeat
    Viewport1.DrawObjectWithRubber(PickedObjects.Current, clTeal);
  until PickedObjects.Next = nil;
  Viewport1.WhereToDraw := [wdOffScreen];
end;

procedure TCADForm.UnShowPickedObjects(Where: TWhereToDraw);
begin
  if PickedObjects.First = nil then Exit;
  { Unshow the objects. }
  Viewport1.WhereToDraw := Where;
  repeat
    Viewport1.DrawObject(PickedObjects.Current);
  until PickedObjects.Next = nil;
  Viewport1.WhereToDraw := [wdOffScreen];
end;

procedure TCADForm.UpdateAreaString;
begin
  with ViewPort1 do
   begin
     VisAreaLbl.Caption := Format('(%f, %f, %f, %f)',
         [ClipRect.Left, ClipRect.Bottom, ClipRect.Right, ClipRect.Top]);
   end;
end;

procedure TCADForm.AddAnObject(Obj: TObject2D);
begin
  { if the object is also visible then add it to the visible list. }
  if Obj.IsVisible(Viewport1.ClipRect) then
   VisibleObjects.Add(Obj);
end;

procedure TCADForm.FormCreate(Sender: TObject);
begin
  CurrAction := caNone;
  VisibleObjects := TObj2DList.Create(1);
  { Set FreeOnClear to false because is the CADCmp that must free
    objects. }
  VisibleObjects.FreeOnClear := False;
  PickedObjects := TObj2DList.Create(1);
  PickedObjects.FreeOnClear := False;
  PickedPoint := -2;
  PickedPointOrigin := Point2D(0, 0);
  { Set the default window. }
  Viewport1.ShowControlPoints := True;
  Viewport1.GridStep := Point2D(10, 10);
  Viewport1.AspectRatio := Viewport1.Width / Viewport1.Height;
  Viewport1.ZoomWindow(Rect2D(-100, -100, 100, 100));
  Viewport1.PopupMenu := PopupMenu1;
  Viewport1.UseProcessMessages := True;
  { Using the above assignament will ensure that only visible objects
    will be redraw. So we can save more time if the draw is big but
    only a little area is visible. }
  Viewport1.ListOfObjects := VisibleObjects;
  CADCmp1.CurrentLayer := 0;
  UpdateAreaString;
  ChangeControlPoints.Caption := '&Hide control points'
end;

procedure TCADForm.FormDestroy(Sender: TObject);
begin
  Viewport1.ListOfObjects := nil;
  PickedObjects.Clear;
  PickedObjects.Free;
  VisibleObjects.Clear;
  VisibleObjects.Free;
end;

procedure TCADForm.ViewPort1MouseMove2D(Sender: TObject;
  Shift: TShiftState; WX, WY: Single);
begin
  { Update the position label. }
  PosLbl.Caption := Format('%f, %f', [WX, WY]);
  { Do the appropriate action. }
  case CurrAction of
   caMakingPoly: begin
                   { Refresh the viewport to simulate the rubber band. }
                   Viewport1.DrawObjectWithRubber(PickedObjects.First, clGreen);
                   { Move the current point. }
                   (PickedObjects.First as TPolyline2D).Points[PickedPoint] :=
                       Point2D(WX, WY);
                   Viewport1.DrawObjectWithRubber(PickedObjects.First, clGreen);
                 end;
   caMove: begin
             Moved := True;
             ShowPickedObjects([wdCanvas]);
             if (PickedPoint > -1) and (PickedObjects.First is TPrimitive2D) then
               TPrimitive2D(PickedObjects.First).Points[PickedPoint] :=
                PickedObjects.First.WorldToObject(Point2D(WX, WY))
             else
              begin
                PickedObjects.First.ModelTransform := SavedTransf;
                PickedObjects.First.MoveTo(Point2D(WX, WY), PickedPointOrigin);
              end;
             { Draw the intermedie object only on the canvas. }
             ShowPickedObjects([wdCanvas]);
           end;
  end;
end;

procedure TCADForm.ViewPort1MouseDown2D(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; WX, WY: Single);
var
  TmpPick: TObject2D;
begin
  { Do the appropriate action. }
  case CurrAction of
   caNone: begin
             { Pick an object. }
             UnshowPickedObjects([wdOffScreen, wdCanvas]);
             PickedObjects.Clear;
             TmpPick := Viewport1.PickObject(Point2D(WX, WY), 6, PickedPoint);
             if TmpPick = nil then
              { if no object was found then an area is select. }
              begin
                CurrAction := caSelectArea;
                InfoLbl.Caption := 'Move the mouse to the second point and release the button';
              end
             else
              begin
                PickedPointOrigin := Point2D(WX, WY);
                PickedObjects.Add(TmpPick);
                ShowPickedObjects([wdCanvas, wdOffScreen]);
                SavedTransf := PickedObjects.First.ModelTransform;
                CurrAction := caMove;
                Moved := False;
                InfoLbl.Caption := 'Picked object ID is ' + IntToStr(TmpPick.ID);
                InfoLbl.Caption := InfoLbl.Caption + ' and it is on layer ' + IntToStr(TmpPick.Layer);
              end;
           end;
   caMakingPoly: if Button = mbRight then
                  begin
                    { Right button end the current action. }
                    CurrAction := caNone;
                    { Add the object to the visible objects list. }
                    AddAnObject(PickedObjects.First);
                    Viewport1.WhereToDraw := [wdOffScreen, wdCanvas];
                    Viewport1.DrawObject(PickedObjects.First);
                    { Reset the normal conditions. }
                    Viewport1.WhereToDraw := [wdOffScreen];
                    PickedObjects.Clear;
                    PickedPoint := -2;
                    InfoLbl.Caption := '';
                  end
                 else
                  begin
                    { Add a new point to the polyline or polygon. }
                    Viewport1.DrawObjectWithRubber(PickedObjects.First, clGreen);
                    Inc(PickedPoint);
                    (PickedObjects.First as TPolyline2D).Points.Add(Point2D(WX, WY));
                    Viewport1.DrawObjectWithRubber(PickedObjects.First, clGreen);
                  end;
   caSelectBaseBlock:
    begin
      (PickedObjects.First as TBlock2D).OriginPoint := Point2D(WX, WY);
      CurrAction := caNone;
      PickedObjects.Clear;
      ViewPort1.ListOfObjects := nil;
      VisibleObjects := Viewport1.ListOfVisibleObjects;
      Viewport1.ListOfObjects := VisibleObjects;
      Viewport1.Repaint;
    end;
  end;
  if CurrAction = caNone then
   PopupMenu1.Autopopup := True
  else
   PopupMenu1.Autopopup := False;
end;

procedure TCADForm.ViewPort1MouseUp2D(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; WX, WY: Single);
var
  TmpRect: TRect2D;
begin
  { Check if an object is selected. }
  case CurrAction of
   caSelectArea: begin
                   UnshowPickedObjects([wdCanvas, wdOffScreen]);
                   Viewport1.Refresh;
                   TmpRect.FirstEdge := Viewport1.ViewToWorld(BeginArea);
                   TmpRect.SecondEdge := Point2D(WX, WY);
                   PickedObjects.Clear;
                   PickedObjects.AddFromList(Viewport1.GroupOfObjects(TmpRect,
                                             gmAllInside));
                   ShowPickedObjects([wdCanvas, wdOffScreen]);
                   CurrAction := caNone;
                   InfoLbl.Caption := 'Picked ' + IntToStr(PickedObjects.Count)
                                      + ' objects';
                 end;
   caPanningP2: begin
                  VisibleObjects.Clear;
                  TmpRect.FirstEdge := Viewport1.ViewToWorld(BeginArea);
                  TmpRect.SecondEdge := Point2D(WX, WY);
                  { Set list of object to nil to permit the zooming function. }
                  Viewport1.ListOfObjects := nil;
                  Viewport1.Panning(TmpRect.Left - TmpRect.Right, TmpRect.Bottom - TmpRect.Top);
                  VisibleObjects := Viewport1.ListOfVisibleObjects;
                  Viewport1.ListOfObjects := VisibleObjects;
                  UpdateAreaString;
                  CurrAction := caNone;
                  InfoLbl.Caption := '';
                end;
   caMove: begin
             CurrAction := caNone;
             if Moved then
              begin
                Viewport1.Repaint;
                ShowPickedObjects([wdCanvas]);
              end;
           end;
  end;
  if CurrAction = caNone then
   PopupMenu1.Autopopup := True
  else
   PopupMenu1.Autopopup := False;
end;

procedure TCADForm.ViewPort1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  case CurrAction of
   caSelectArea: BeginArea := Point2D(X, Y);
   caPanningP1: begin
                  BeginArea := Point2D(X, Y);
                  CurrAction := caPanningP2;
                  InfoLbl.Caption := 'Move the mouse to the second point and release the button';
                end;
  end;
end;

procedure TCADForm.ViewPort1MouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
begin
  if (CurrAction = caSelectArea) then
  { Draw the area rectangle if current state is select area. }
   begin
     Viewport1.Refresh;
     Viewport1.Canvas.Pen.Style := psDot;
     Viewport1.Canvas.Pen.Width := 2;
     Viewport1.Canvas.Pen.Mode := pmXOr;
     Viewport1.Canvas.Pen.Color := clGray;
     Viewport1.Canvas.MoveTo(Trunc(BeginArea.X), Trunc(BeginArea.Y));
     Viewport1.Canvas.LineTo(Trunc(BeginArea.X), Y);
     Viewport1.Canvas.LineTo(X, Y);
     Viewport1.Canvas.LineTo(X, Trunc(BeginArea.Y));
     Viewport1.Canvas.LineTo(Trunc(BeginArea.X), Trunc(BeginArea.Y));
   end
  else if (CurrAction = caPanningP2) then
   begin
     Viewport1.Refresh;
     Viewport1.Canvas.Pen.Style := psDot;
     Viewport1.Canvas.Pen.Width := 2;
     Viewport1.Canvas.Pen.Mode := pmXOr;
     Viewport1.Canvas.Pen.Color := clGray;
     Viewport1.Canvas.MoveTo(Trunc(BeginArea.X), Trunc(BeginArea.Y));
     Viewport1.Canvas.LineTo(X, Y);
   end;
end;

procedure TCADForm.ChangeControlPointsClick(Sender: TObject);
begin
  Viewport1.ShowControlPoints := not Viewport1.ShowControlPoints;
  if Viewport1.ShowControlPoints then
   ChangeControlPoints.Caption := '&Hide control points'
  else
   ChangeControlPoints.Caption := 'S&how control points';
  Viewport1.Repaint;
end;

procedure TCADForm.Line1Click(Sender: TObject);
var
 Tmp: TLine2D;
begin
  { Set the viewport in write on canvas, so you can see the object
    without use the repaint metods. }
  Viewport1.WhereToDraw := Viewport1.WhereToDraw + [wdCanvas];
  { Add the line to the cad. }
  Tmp := TLine2D.Create(-1, Point2D(0, 0), Point2D(10, 0));
  CADCmp1.AddObject(-1, Tmp);
  AddAnObject(Tmp);
  { Reset the viewport in write off screen only, so you cannot
    view flickering. }
  Viewport1.WhereToDraw := Viewport1.WhereToDraw - [wdCanvas];
end;

procedure TCADForm.Polyline1Click(Sender: TObject);
var
  Tmp: TPolyline2D;
begin
  UnshowPickedObjects([wdCanvas, wdOffScreen]);
  { Set the viewport in write on canvas, so you can see the object
    without use the repaint metods. }
  Viewport1.WhereToDraw := [wdCanvas];
  { Add the polyline to the CAD and start the action of make polyline. }
  PickedObjects.Clear;
  Tmp := TPolyline2D.Create(-1, [Point2D(0, 0)]);
  CADCmp1.AddObject(-1, Tmp);
  PickedObjects.Add(Tmp);
  Viewport1.Refresh;
  { Draw the first object to start the rubber band. }
  Viewport1.DrawObjectWithRubber(PickedObjects.First, clGreen);
  PickedPoint := 0;
  CurrAction := caMakingPoly; 
  InfoLbl.Caption := 'Move the mouse to the desired points';
end;

procedure TCADForm.Polygon1Click(Sender: TObject);
var
  Tmp: TPolygon2D;
begin
  UnshowPickedObjects([wdCanvas, wdOffScreen]);
  { Set the viewport in write on canvas, so you can see the object
    without use the repaint metods. This made possible the rubber
    band method. }
  Viewport1.WhereToDraw := [wdCanvas];
  { Start the action of make polyline. }
  PickedObjects.Clear;
  Tmp := TPolygon2D.Create(-1, [Point2D(0, 0)]);
  CADCmp1.AddObject(-1, Tmp);
  PickedObjects.Add(Tmp);
  Viewport1.Refresh;
  { Draw the first object to start the rubber band. }
  Viewport1.DrawObjectWithRubber(PickedObjects.First, clGreen);
  PickedPoint := 0;
  CurrAction := caMakingPoly;
  InfoLbl.Caption := 'Move the mouse to the desired points';
end;

procedure TCADForm.Rectangle1Click(Sender: TObject);
var
  Tmp: TRectangle2D;
begin
  { Set the viewport in write on canvas, so you can see the object
    without use the repaint metods. }
  Viewport1.WhereToDraw := Viewport1.WhereToDraw + [wdCanvas];
  { Add the rectangle to the cad. }
  Tmp := TRectangle2D.Create(-1, Point2D(0, 0), Point2D(20, 20));
  CADCmp1.AddObject(-1, Tmp);
  AddAnObject(Tmp);
  { Reset the viewport in write off screen only, so you cannot
    view flickering. }
  Viewport1.WhereToDraw := Viewport1.WhereToDraw - [wdCanvas];
end;

procedure TCADForm.Ellipse1Click(Sender: TObject);
var
  Tmp: TEllipse2D;
begin
  { Set the viewport in write on canvas, so you can see the object
    without use the repaint metods. }
  Viewport1.WhereToDraw := Viewport1.WhereToDraw + [wdCanvas];
  { Add the ellipse to the cad. }
  Tmp := TEllipse2D.Create(-1, Point2D(0, 0), Point2D(20, 20));
  CADCmp1.AddObject(-1, Tmp);
  AddAnObject(Tmp);
  { Reset the viewport in write off screen only, so you cannot
    view flickering. }
  Viewport1.WhereToDraw := Viewport1.WhereToDraw - [wdCanvas];
end;

procedure TCADForm.Text1Click(Sender: TObject);
var
  Tmp: TText2D;
  TmpStr: String;
begin
  TmpStr := 'Text';
  if InputQuery('Text', 'Text string:', TmpStr) then
   begin
     { Set the viewport in write on canvas, so you can see the object
       without use the repaint metods. }
     Viewport1.WhereToDraw := Viewport1.WhereToDraw + [wdCanvas];
     { Add the text to the cad. }
     Tmp := TText2D.Create(-1, Point2D(0, 0), 10, TmpStr);
     CADCmp1.AddObject(-1, Tmp);
     AddAnObject(Tmp);
     ViewPort1.Repaint;
     { Reset the viewport in write off screen only, so you cannot
       view flickering. }
     Viewport1.WhereToDraw := Viewport1.WhereToDraw - [wdCanvas];
   end;
end;

procedure TCADForm.Arc1Click(Sender: TObject);
var
  Tmp: TArc2D;
begin
  { Set the viewport in write on canvas, so you can see the object
    without use the repaint metods. }
  Viewport1.WhereToDraw := Viewport1.WhereToDraw + [wdCanvas];
  { Add the arc to the cad. }
  Tmp := TArc2D.Create(-1, Point2D(0, 0), Point2D(10, 10), 0, Pi/2);
  CADCmp1.AddObject(-1, Tmp);
  AddAnObject(Tmp);
  ViewPort1.Repaint;
  { Reset the viewport in write off screen only, so you cannot
    view flickering. }
  Viewport1.WhereToDraw := Viewport1.WhereToDraw - [wdCanvas];
end;

procedure TCADForm.ZoomArea1Click(Sender: TObject);
begin
  ZoomForm.ShowModal;
  VisibleObjects.Clear;
  { Set list of object to nil to permit the zooming function. }
  Viewport1.ListOfObjects := nil;
  Viewport1.ZoomWindow(ZoomForm.ZoomRect);
  VisibleObjects := Viewport1.ListOfVisibleObjects;
  Viewport1.ListOfObjects := VisibleObjects;
  UpdateAreaString;
  CurrAction := caNone;
  InfoLbl.Caption := '';
end;

procedure TCADForm.Moveobjectstoblock1Click(Sender: TObject);
var
  TmpBlk: TObject2D;
begin
  if PickedObjects.Count > 0 then
   begin
     UnshowPickedObjects([wdCanvas, wdOffScreen]);
     ViewPort1.ListOfObjects := nil;
     CADCmp1.RemoveObjects(PickedObjects);
     CADCmp1.BlockObjects(MyNextID, PickedObjects);
     TmpBlk := CADCmp1.NewBlock(-1, MyNextID);
     Inc(MyNextID);
     PickedObjects.Clear;
     PickedObjects.Add(TmpBlk);
     ShowPickedObjects([wdCanvas]);
     CurrAction := caSelectBaseBlock;
   end;
end;

procedure TCADForm.Copyblock1Click(Sender: TObject);
begin
  if (PickedObjects.Count = 1) and (PickedObjects.First is TBlock2D) then
   begin
     UnshowPickedObjects([wdCanvas, wdOffScreen]);
     Viewport1.WhereToDraw := Viewport1.WhereToDraw + [wdCanvas];
     AddAnObject(CADCmp1.NewBlock(-1, TBlock2D(PickedObjects.First).SourceBlock.ID));
     { Reset the viewport in write off screen only, so you cannot
       view flickering. }
     Viewport1.WhereToDraw := Viewport1.WhereToDraw - [wdCanvas];
   end;
end;

procedure TCADForm.Delete1Click(Sender: TObject);
begin
  if PickedObjects.First = nil then Exit;
  { Remember to set ListOfObjects to nil before delete objects from
    CADCmp. This will prevent the redraw of a deleted object. }
  ViewPort1.ListOfObjects := nil;
  { Delete the objects. }
  CADCmp1.DeleteObjects(PickedObjects);
  PickedObjects.Clear;
  VisibleObjects := Viewport1.ListOfVisibleObjects;
  Viewport1.ListOfObjects := VisibleObjects;
  Viewport1.Repaint;
end;

procedure TCADForm.Showgrid1Click(Sender: TObject);
begin
  if Viewport1.GridStep.X = 0 then
   begin
     ShowGrid1.Caption := 'Hide &grid';
     Viewport1.GridStep := Point2D(10, 10);
   end
  else
   begin
     ShowGrid1.Caption := 'Show &grid';
     Viewport1.GridStep := Point2D(0, 0);
   end;
  Viewport1.Repaint;
end;

procedure TCADForm.ZoomAll1Click(Sender: TObject);
begin
  if CADCmp1.First = nil then Exit;
  VisibleObjects.Clear;
  { Set list of object to nil to permit the zooming function. }
  Viewport1.ListOfObjects := nil;
  { Update the extension of the draw. }
  CADCmp1.UpdateExtension;
  Viewport1.ZoomExtension;
  VisibleObjects := Viewport1.ListOfVisibleObjects;
  Viewport1.ListOfObjects := VisibleObjects;
  UpdateAreaString;
end;

procedure TCADForm.ZoomIn1Click(Sender: TObject);
begin
  VisibleObjects.Clear;
  { Set list of object to nil to permit the zooming function. }
  Viewport1.ListOfObjects := nil;
  Viewport1.ZoomIn;
  VisibleObjects := Viewport1.ListOfVisibleObjects;
  Viewport1.ListOfObjects := VisibleObjects;
  UpdateAreaString;
end;

procedure TCADForm.ZoomOut1Click(Sender: TObject);
begin
  VisibleObjects.Clear;
  { Set list of object to nil to permit the zooming function. }
  Viewport1.ListOfObjects := nil;
  Viewport1.ZoomOut;
  VisibleObjects := Viewport1.ListOfVisibleObjects;
  Viewport1.ListOfObjects := VisibleObjects;
  UpdateAreaString;
end;

procedure TCADForm.Aspectratio1Click(Sender: TObject);
var
  TmpValue: String;
begin
  TmpValue := FloatToStr(Viewport1.AspectRatio);
  if InputQuery('Set aspect ratio', 'Aspect ratio:', TmpValue) then
   begin
     Viewport1.AspectRatio := StrToFloat(TmpValue);
     Viewport1.Repaint;
   end;
end;

procedure TCADForm.Open1Click(Sender: TObject);
var
  TmpStream: TFileStream;
begin
  if OpenDialog1.Execute then
   begin
     TmpStream := TFileStream.Create(OpenDialog1.FileName, fmOpenRead);
     try
       TmpStream.Seek(0, 0);
       CADCmp1.LoadFromStream(TmpStream);
       ZoomAll1Click(nil);
     finally
       TmpStream.Free;
     end;
   end;
end;

procedure TCADForm.Save1Click(Sender: TObject);
var
  TmpStream: TFileStream;
begin
  if SaveDialog1.Execute then
   begin
     TmpStream := TFileStream.Create(SaveDialog1.FileName, fmCreate or fmOpenWrite);
     try
       TmpStream.Seek(0, 0);
       CADCmp1.SaveToStream(TmpStream);
     finally
       TmpStream.Free;
     end;
   end;
end;

procedure TCADForm.Panning1Click(Sender: TObject);
begin
  CurrAction := caPanningP1;
  InfoLbl.Caption := 'Move the mouse to the first point and press the left button';
end;

procedure TCADForm.Layers1Click(Sender: TObject);
begin
  LayersDlg := TLayersDlg.Create(Self);
  try
   LayersDlg.ShowModal;
   Viewport1.Repaint;
  finally
   LayersDlg.Free;
  end;
end;

procedure TCADForm.SpinLayerChange(Sender: TObject);
begin
  CADCmp1.CurrentLayer := SpinLayer.Value;
  if PickedObjects.First <> nil then
   PickedObjects.First.Layer := SpinLayer.Value;
end;

procedure TCADForm.Quit1Click(Sender: TObject);
begin
  ShowMessage('This is the powerful of Delphi :o');
  Close;
end;

procedure TCADForm.Rotate1Click(Sender: TObject);
var
  TmpTrasf: TTransf2D;
begin
  if (PickedObjects.First <> nil) and (PickedObjects.First is TText2D) then
   begin
     (PickedObjects.First as TText2D).LogFont.lfEscapement :=
        (PickedObjects.First as TText2D).LogFont.lfEscapement - 100;
     Viewport1.Repaint;
     ShowPickedObjects([wdCanvas]);
   end
  else
   begin
     TmpTrasf := PickedObjects.First.ModelTransform;
     TmpTrasf := MultiplyTransf2D(Rotate2D(Pi / 10), TmpTrasf);
     PickedObjects.First.ModelTransform := IdentityTransf2D;
     PickedObjects.First.Transform(TmpTrasf);
     Viewport1.Repaint;
     ShowPickedObjects([wdCanvas]);
   end;
end;

procedure TCADForm.BSpline1Click(Sender: TObject);
var
  Tmp: TObject2D;
begin
  UnshowPickedObjects([wdCanvas, wdOffScreen]);
  { Set the viewport in write on canvas, so you can see the object
    without use the repaint metods. }
  Viewport1.WhereToDraw := [wdCanvas];
  { Add the spline to the CAD and start the action of make spline. }
  PickedObjects.Clear;
  Tmp := TBSpline2D.Create(0, [Point2D(0, 0)]);
  CADCmp1.AddObject(-1, Tmp);
  PickedObjects.Add(Tmp);
  Viewport1.Refresh;
  { Draw the first object to start the rubber band. }
  Viewport1.DrawObjectWithRubber(PickedObjects.First, clGreen);
  PickedPoint := 0;
  CurrAction := caMakingPoly;
  InfoLbl.Caption := 'Move the mouse to the desired points';
end;

procedure TCADForm.Test1Click(Sender: TObject);
var
  Cont: LongInt;
  Tmp: TLine2D;
begin
  SetTime;
  CADCmp1.DrawOnAdd := False;
  for Cont := 1 to 10000 do
   begin
     Tmp := TLine2D.Create(-1, Point2D(0, Cont), Point2D(1000, Cont));
     CADCmp1.AddObject(-1, Tmp);
   end;
  CADCmp1.DrawOnAdd := True;
  ShowTime;
  SetTime;
  VisibleObjects.Clear;
  { Set list of object to nil to permit the zooming function. }
  Viewport1.ListOfObjects := nil;
  { Update the extension of the draw. }
  CADCmp1.UpdateExtension;
  Viewport1.ZoomExtension;
  VisibleObjects := Viewport1.ListOfVisibleObjects;
  Viewport1.ListOfObjects := VisibleObjects;
  UpdateAreaString;
  { On a 100Mhz Pentium with 256Kb of secondary cache, 16Mb of RAM, Cirrus Logic
    PCI card with 1Mb DRam:
      Create time = 610ms
      Full Redraw = 770ms }
  ShowTime;
end;

procedure TCADForm.CADCmp1ListChange(Sender: TObject; NewObj: TObject2D);
begin
  ZoomForm.HasChanged := True;
end;

procedure TCADForm.Setgridstep1Click(Sender: TObject);
var
  TmpValue: String;
begin
  TmpValue := FloatToStr(Viewport1.GridStep.X);
  if InputQuery('Set grid step', 'X step:', TmpValue) then
   Viewport1.GridStep := Point2D(StrToFloat(TmpValue), Viewport1.GridStep.Y);
  TmpValue := FloatToStr(Viewport1.GridStep.Y);
  if InputQuery('Set grid step', 'Y step:', TmpValue) then
   Viewport1.GridStep := Point2D(Viewport1.GridStep.X, StrToFloat(TmpValue));
  Viewport1.Repaint;
end;

procedure TCADForm.Doubleextension1Click(Sender: TObject);
begin
  CADCmp1.TransformObjects([-1], Scale2D(2.0, 2.0));
  ZoomForm.HasChanged := True;
  Viewport1.Repaint;
end;

procedure TCADForm.Divideextension1Click(Sender: TObject);
begin
  CADCmp1.TransformObjects([-1], Scale2D(0.5, 0.5));
  ZoomForm.HasChanged := True;
  Viewport1.Repaint;
end;

procedure TCADForm.Print1Click(Sender: TObject);
var
 T1, T2, T3: TRealType;
 TmpTransf: TRect2D;
begin
  T1 := Viewport1.AspectRatio;
  TmpTransf := Viewport1.ClipRect;
  Printer.BeginDoc;
  with Printer.Canvas do
   try
     Viewport1.OffScreenCanvas := Printer.Canvas;
     CADCmp1.UpdateExtension;
     Viewport1.AspectRatio := Abs(ClipRect.Right - ClipRect.Left) /
                              Abs(ClipRect.Top - ClipRect.Bottom);
     Viewport1.ZoomExtension;
     Viewport1.BackGroundColor := clWhite;
   finally
     Viewport1.OffScreenCanvas := nil;
     Viewport1.BackGroundColor := clSilver;
     Viewport1.AspectRatio := T1;
     Viewport1.ZoomWindow(TmpTransf);
     Viewport1.Repaint;
     Printer.EndDoc;
   end;
end;

end.
