unit Layerdlg;

interface

uses WinTypes, WinProcs, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, ExtCtrls, TabNotBk, SysUtils;

type
  TLayersDlg = class(TForm)
    OKBtn: TBitBtn;
    Bevel1: TBevel;
    ListBox1: TListBox;
    Label1: TLabel;
    TabbedNotebook1: TTabbedNotebook;
    VisibleChk: TCheckBox;
    PenColorCb: TComboBox;
    PenSizeCb: TComboBox;
    PenStyleCb: TComboBox;
    SampleShape: TShape;
    Label4: TLabel;
    BrushColorCb: TComboBox;
    BrushStyleCb: TComboBox;
    OpaqueChk: TCheckBox;
    procedure ListBox1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ChangeLayer(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  LayersDlg: TLayersDlg;

implementation

uses CADFrm;

{$R *.DFM}

const
 Colors: array[0..17] of TColor = (clBlack,
   clMaroon,
   clGreen,
   clOlive,
   clNavy,
   clPurple,
   clTeal,
   clGray,
   clSilver,
   clRed,
   clLime,
   clYellow,
   clBlue,
   clFuchsia,
   clAqua,
   clLtGray,
   clDkGray,
   clWhite);

var
  Initial: Boolean;

function ColorIndex(Color: TColor): Byte;
var
  Cont: Byte;
begin
  for Cont := 0 to 17 do
   if Color = Colors[Cont] then
    begin
      Result := Cont;
      Break;
    end;
end;

function IndexColor(Index: Byte): TColor;
begin
  Result := Colors[Index];
end;

procedure TLayersDlg.ListBox1Click(Sender: TObject);
begin
  PenColorCb.ItemIndex := ColorIndex(CADForm.CADCmp1.Layers[ListBox1.ItemIndex].Pen.Color);
  PenSizeCb.ItemIndex := CADForm.CADCmp1.Layers[ListBox1.ItemIndex].Pen.Width - 1;
  PenStyleCb.ItemIndex := Ord(CADForm.CADCmp1.Layers[ListBox1.ItemIndex].Pen.Style);
  BrushColorCb.ItemIndex := ColorIndex(CADForm.CADCmp1.Layers[ListBox1.ItemIndex].Brush.Color);
  BrushStyleCb.ItemIndex := Ord(CADForm.CADCmp1.Layers[ListBox1.ItemIndex].Brush.Style);
  OpaqueChk.Checked := CADForm.CADCmp1.Layers[ListBox1.ItemIndex].Opaque;
  VisibleChk.Checked := CADForm.CADCmp1.Layers[ListBox1.ItemIndex].Active;
  SampleShape.Pen.Assign(CADForm.CADCmp1.Layers[ListBox1.ItemIndex].Pen);
  SampleShape.Brush.Assign(CADForm.CADCmp1.Layers[ListBox1.ItemIndex].Brush);
end;

procedure TLayersDlg.FormCreate(Sender: TObject);
var
  Cont: Byte;
begin
  Initial := True;
  ListBox1.Items.Clear;
  for Cont := 0 to 255 do
   ListBox1.Items.Add('Layer ' + IntToStr(Cont));
  ListBox1.ItemIndex := 0;
  ListBox1Click(nil);
  Initial := False;
end;

procedure TLayersDlg.ChangeLayer(Sender: TObject);
begin
  if Initial then Exit;
  CADForm.CADCmp1.Layers[ListBox1.ItemIndex].Pen.Color := IndexColor(PenColorCb.ItemIndex);
  CADForm.CADCmp1.Layers[ListBox1.ItemIndex].Pen.Width := PenSizeCb.ItemIndex + 1;
  CADForm.CADCmp1.Layers[ListBox1.ItemIndex].Pen.Style := TPenStyle(PenStyleCb.ItemIndex);
  CADForm.CADCmp1.Layers[ListBox1.ItemIndex].Brush.Color := IndexColor(BrushColorCb.ItemIndex);
  CADForm.CADCmp1.Layers[ListBox1.ItemIndex].Brush.Style := TBrushStyle(BrushStyleCb.ItemIndex);
  CADForm.CADCmp1.Layers[ListBox1.ItemIndex].Active := VisibleChk.Checked;
  CADForm.CADCmp1.Layers[ListBox1.ItemIndex].Opaque := OpaqueChk.Checked;
  SampleShape.Pen.Assign(CADForm.CADCmp1.Layers[ListBox1.ItemIndex].Pen);
  SampleShape.Brush.Assign(CADForm.CADCmp1.Layers[ListBox1.ItemIndex].Brush);
end;

end.
